/*debugfuncs.c*/
/*--------------------------Licensed under GNU General Public License---------------------

see header in aducprog.c or license in gpl.txt for details.
-----------------------------------------------------------------------------------------*/



#include <stdio.h>
#include <time.h>
#include "globdefs.h"
#include "userint.h"


extern Status status;

void dumpstatus()
{
printf ("\ndumping status and globals at time: %s\n",getdatetime());
printf ("------------\n");
printf ("SOFTTITLE: %s\n", SOFTTITLE);
printf ("SOFTVER: %s\n", SOFTVER);
printf ("REVDATE: %s\n", REVDATE);
printf ("status.starttime: %s\n", status.starttimest);
printf ("status.product_id: %s\n",status.product_id);
printf ("status.firmware_id: %s\n",status.firmware_id);
printf ("status.hardware_config: 0x%x 0x%x\n",status.hardware_config[0],
                                                status.hardware_config[1]);
printf ("status.serialopen: %i\n",status.serialopen);
printf ("status.interrogated: %i\n",status.interrogated);
printf ("status.interonly: %i\n",status.interronly);
printf ("status.eraseprogm: %i\n",status.eraseprogm);
printf ("status.progprogm: %i\n",status.progprogm);
printf ("status.setsecurity: %i\n",status.setsecurity);
printf ("status.runataddr: %i\n",status.runataddr);
printf ("status.etim: %i\n",status.etim);
printf ("status.progdatam: %i\n",status.progdatam);
printf ("status.eraseallm: %i\n",status.eraseallm);
printf ("status.hereline: %i\n",status.hereline);
printf ("------------\n");
}
