/*errhand.c*/
/*functions to die gracefully and provide decent information*/
/*lots of extry stuff in here that probably ought to be pulled..*/
/*has features to build up an error list..*/
/*but not much tested...*/

/*--------------------------Licensed under GNU General Public License---------------------

see header in aducprog.c or license in gpl.txt for details.
-----------------------------------------------------------------------------------------*/
#include <time.h>
#include <stdio.h>
#include <string.h>	/*for strerror!*/
#include <errno.h>
#include "globdefs.h"	/*for ERRLOG filename*/
#include "errhand.h"	/*some #definitions..*/
#include "stdlib.h"	/*for exit!*/

char errlist[MAXERRSPACE];	/*errlist must be defined one place!*/
				/*this is the string where errors are logged during the test*/


void erradd(char *msg)  	/*adds an error to the errlist*/
{
if ((strlen(errlist) + strlen(msg) + 3) <  MAXERRSPACE)  {
    strcat(errlist, "\n");
    strcat(errlist,msg);
}
else {
    die ("No room left in errlist!");
}
} /*end erradd*/

void clearerrs()
{
    errlist[0] = '\0';	/*reset string end to beginning*/
}


void die(char *msg)	/*print message, log and exit*/
{
FILE *errlog;
time_t systime_space;
time_t *systime;  /*systime is a pointer to a time_t struct*/
char *checkouttime;		/*for local time*/
int fileerror;	                /*in case of error on log...*/
char logfilename[] = ERRLOG;
char nomessage[] = "No message from caller";

systime = &systime_space;	/*pointer to space for time*/

time(systime);
checkouttime = ctime(systime);
if ((strcmp(msg,"") == 0)) msg=nomessage;

if((errlog = fopen(logfilename,"a"))) {		/*ok, we got the file pointer*/

    fprintf (stderr, "\n-----------------ERROR EXIT, at %s-------------------------", checkouttime);
    fprintf (stderr, "\nmessage: %s", msg);
    fprintf (stderr, "\nlogged in %s",logfilename);
    fprintf (stderr, "--------------------------EXIT---------------------------\n\n");
    fprintf (errlog, "\n-----------------EXIT thru die, at %s", checkouttime);	/*log*/
    fprintf (errlog, "\nmessage: %s", msg);
    fprintf (errlog, "%s\n", errlist);
    fprintf (errlog, "\nerrno %i, says: %s\n", errno, strerror(errno));
    fprintf (errlog, "--------------------------EXIT---------------------------\n\n");
    if ((fileerror = ferror(errlog)))
        fprintf (stderr, "\nfrom ferror, error # %i trying to write to logfile %s!\n",fileerror,logfilename);
    fclose(errlog);
}  /*end, if fopen*/
else  {
    fprintf (stderr, "\n-----------------EXIT thru die, at %s", checkouttime);
    fprintf (stderr, "\nERROR, open error log fail in die!");
    fprintf (stderr, "\nmessage: %s", msg);
    fprintf (stderr, "\nerrno %i, says: %s\n", errno, strerror(errno));
    fprintf (stderr, "--------------------------EXIT---------------------------\n\n");
}  /*end, didn't manage to get file pointer*/
exit(1);	/*exit with fail code 1*/
}


void warn(char *msg)
{
fprintf(stderr, "\nWARNING::%s\n",msg);
}
void NOTwarn(char *msg)	/*print message, log*/
{
FILE *errlog;
time_t systime_space;
time_t *systime;  /*systime is a pointer to a time_t struct*/
char *checkouttime;		/*for local time*/
int fileerror;	                /*in case of error on log...*/
char logfilename[] = ERRLOG;
char nomessage[] = "No message from caller";
		
systime = &systime_space;	/*pointer to space for time*/

time(systime);
checkouttime = ctime(systime);
if ((strcmp(msg,"") == 0)) msg=nomessage; 			

if((errlog = fopen(logfilename,"a"))) {		/*ok, we got the file pointer*/

    fprintf (stderr, "\n-----------------WARNING, at %s", checkouttime);
    fprintf (stderr, "\nmessage: %s", msg);
    fprintf (stderr, "\nsee file %s for details",logfilename);
    fprintf (stderr, "\nerrno %i, says: %s\n", errno, strerror(errno));
    fprintf (stderr, "--------------------------WARN---------------------------\n\n");

    fprintf (errlog, "\n-----------------WARNING, at %s", checkouttime);	/*log*/
    fprintf (errlog, "\nmessage: %s", msg);
    fprintf (errlog, "%s\n", errlist);
    fprintf (errlog, "\nerrno %i, says: %s\n", errno, strerror(errno));
    fprintf (errlog, "--------------------------WARN---------------------------\n\n");
    if ((fileerror = ferror(errlog)))
        fprintf (stderr, "\nfrom ferror, error # %i trying to write to logfile %s!\n",fileerror,logfilename);
    fclose(errlog);
    fflush(stderr);
}  /*end, if fopen*/
else  {
    fprintf (stderr, "\n-----------------EXIT thru die, at %s", checkouttime);
    fprintf (stderr, "\nERROR, open error log fail in warn!");
    fprintf (stderr, "\nmessage: %s", msg);
    fprintf (stderr, "\nerrno %i, says: %s\n", errno, strerror(errno));
    fprintf (stderr, "--------------------------EXIT---------------------------\n\n");
    exit(1);	/*still terminate program on write to errlog fail!*/
}  /*end, didn't manage to get file pointer*/
}	/*return from void warn(char *msg)*/

void logwrite(char *msg)		/*writes a message to logfile*/
{
FILE *logfile;
char logfilename[] = LOGFILE;
time_t systime_space;
time_t *systime;  /*systime is a pointer to a time_t struct*/
char *heretime;		/*for local time*/
int fileerror;	                /*in case of error on log...*/
		
systime = &systime_space;	/*pointer to space for time*/

time(systime);
heretime = ctime(systime); /*nicely printed time*/

if ((logfile = fopen(logfilename,"a"))) { /*Ok, managed to open log file*/
	fprintf(logfile, "\n----------------%s",heretime);
	fprintf(logfile, "\n%s\n",msg);
	fprintf(logfile, "\n-----------------------------------------------------------------");
        if ((fileerror = ferror(logfile)))
        fprintf (stderr, "\nfrom ferror, error # %i trying to write to logfile %s!\n",fileerror,logfilename);
}
else {
	die ("couldn't open logfile!");
     }
fclose(logfile);		/*yeesh... was getting backwards time in logfile!*/
} /*end void logwrite*/
