/*errhand.h*/
/*error handling and exit with (hopefully) some usefull information!*/


#define MAXERRSPACE 2048

extern char errlist[];		/*points to error list...*/
				/*errlist points to static storage in defined in errhand.c file*/

void die(char *diemess);	/*function to print error message, print to log and exit!*/
				/*does NOT include shutdown!*/
				/*meant as exit from software error trap*/
void warn(char *warnmess);	/*prints error message to stderr and error log*/

void clearerrs();		/*clears errors in errlist*/

void erradd(char *msg);		/*adds message to error list*/

