/*globdefs.h*/
/*defines data structures, special numbers, limits for test*/

#include <time.h>			/*just for time_t!*/
#define SOFTTITLE "aducprog ADUC microconverter host program" 	/*software title*/
#define SOFTVER "NONE"			/*test sw version #*/
#define REVDATE "2002-07-14"		/*test sw date*/
                                        /*update by Make???*/

#define LOGFILE "LOGFILE.TXT"		/*normal operation log file*/
#define ERRLOG  "LOGFILE.TXT"		/*error log file*/

#define TRUE  1
#define FALSE 0
typedef int flag;               //flag defined as enum causes
                                //compiler warnings for getopt_long struct
typedef unsigned char byte;

struct status {
	char starttimest[24];	/*time when last record file opened, string format*/
	char product_id[16];    //product ID read from target part
	char firmware_id[8];    //firmware version read from target part
        char hardware_config[4]; //hardware configuration, and space for 0
        flag serialopen;        //serial channel open
        flag interrogated;
                                //runtime options
        flag interronly;         //-i interrogate only
        flag eraseprogm;        //-e erase prog mem
        flag progprogm;          //-p prog program memory
        flag setsecurity;       //-s set security mode
        flag runataddr;         //-r target jump to address
        flag etim;              //-t set ETIM registers
        flag progdatam;         //-d program data memory
        flag eraseallm;        //-z erase program and data memory
	flag checkfile;		//-c check the hex file
	int serdev;		//'-1' option, use ttyS1, else use ttyS0
        int hereline;                           //cheesy "line number" for recording __LINE__ macro
	};

typedef struct status Status;

char infilename[256];                           //input file name as string
char listfilename[256];                            //these are defined in aducprog.c





